# -*- coding: utf-8 -*-
"""Data.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1xfKBt1j2GU9e2E8TwenKzBPA13_7s0qe
"""

#!pip install alpha_vantage
from alpha_vantage.timeseries import TimeSeries
from alpha_vantage.techindicators import TechIndicators

#Data class

class Data:
  def __init__(self,API_key, symbol, interval):
    self.API_key = API_key
    self.symbol = symbol
    self.interval = interval
  def import_data(self):
    ts = TimeSeries(key=self.API_key, output_format='pandas')
    data=ts.get_intraday(self.symbol, interval = self.interval, outputsize = 'full') # We use 5-min interval to determine the time when traders make investment decisions.
    data[0].rename(columns={'1. open':'open', '2. high':'high', '3. low':'low', '4. close':'close', '5. volume':'volume'}, inplace = True)
    all_df = data[0]
    num = int(3/5 * all_df.shape[0])
    all_df.sort_index(ascending=True, inplace=True)

    ti = TechIndicators(key=self.API_key, output_format='pandas')
    vwap_data=ti.get_vwap(self.symbol, interval=self.interval)
    vwap_df = vwap_data[0]
    all_df = all_df.merge(vwap_df, how='inner', left_on='date', right_index=True)

    df = all_df.iloc[num:].copy()
    return df