# -*- coding: utf-8 -*-
"""signal_figure.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1-pgAznkpmEGRRA1olFYDdSLFidPkAr6z
"""
import pandas as pd
import matplotlib.pyplot as plt

class signal_figure:
  def __init__(self, prices, signals, topic):
    self.prices = prices
    self.signals = signals
    self.topic = topic
  def signal_figure(self):
    close = self.prices[['close', 'VWAP']]
    close = close.merge(self.signals,how='inner',left_index=True, right_index=True)
    close = close.sort_values(by='date')
    close.index = pd.to_datetime(close.index)
    fig = plt.figure(1, figsize = (18,8))
    plt.plot(close.close, color='b', lw=1., label = 'Stock Price')
    plt.plot(close.VWAP, color='y', lw=1., label = 'VWAP line')
    plt.plot(close.loc[close.positions == 1.0].index, close.close[close.positions == 1.0], '^', markersize=5, color='green',label = 'buying signal')
    plt.plot(close.loc[close.positions == -1.0].index, close.close[close.positions == -1.0], 'v', markersize=5, color='red',label = 'selling signal')
    plt.xlabel('Date')
    plt.ylabel('Dollars')
    plt.title(self.topic + ' Price')
    plt.legend()
    #plt.show()
    plt.savefig(f'Stock Price & VWAP Line for {self.topic}')
    return close